//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd,com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  PaleVioletRed
#property indicator_color4  Green
#property indicator_color5  Orange
#property indicator_color6  Orange
#property indicator_color7  DeepSkyBlue
#property indicator_color8  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_width7  2
#property indicator_width8  2

//
//
//
//
//

extern string TimeFrame       = "current time frame";
extern int    FastHullLength  = 15;
extern int    FastHullPrice   = PRICE_CLOSE;
extern int    SlowHullLength  = 30;
extern int    SlowHullPrice   = PRICE_CLOSE;
extern bool   MultiColor      = true;
extern bool   ArrowsVisible   = true;
extern int    ArrowUpCode     = 159;
extern int    ArrowDownCode   = 159;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   Interpolate     = true;

//
//
//
//
//

double hma[];
double hmada[];
double hmadb[];
double hmb[];
double hmbda[];
double hmbdb[];
double arrUp[];
double arrDn[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

int init()
{
      SetIndexBuffer(0,hma);
      SetIndexBuffer(1,hmada);
      SetIndexBuffer(2,hmadb);
      SetIndexBuffer(3,hmb);
      SetIndexBuffer(4,hmbda);
      SetIndexBuffer(5,hmbdb);
      SetIndexBuffer(6,arrUp); SetIndexArrow(6,ArrowUpCode);
      SetIndexBuffer(7,arrDn); SetIndexArrow(7,ArrowDownCode);

         if (MultiColor)
               { SetIndexStyle(1,DRAW_LINE); SetIndexStyle(2,DRAW_LINE); SetIndexStyle(4,DRAW_LINE); SetIndexStyle(5,DRAW_LINE); }
         else  { SetIndexStyle(1,DRAW_NONE); SetIndexStyle(2,DRAW_NONE); SetIndexStyle(4,DRAW_NONE); SetIndexStyle(5,DRAW_NONE); }
         if (ArrowsVisible)
               { SetIndexStyle(6,DRAW_ARROW); SetIndexStyle(7,DRAW_ARROW); }
         else  { SetIndexStyle(6,DRAW_NONE);  SetIndexStyle(7,DRAW_NONE);  }

      //
      //
      //
      //
      //
   
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame=="returnBars";     if (returnBars)     return(0);
      calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
   //
   //
   //
   //
   //
         
   IndicatorShortName(timeFrameToString(timeFrame)+" zero lag HMA CD ("+FastHullLength+")");         
   return(0);
}
int deinit() { return(0); }

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

double trends[][3];

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { hma[0] = limit+1; return(0); }
         if (ArrayRange(trends,0)!=Bars) ArrayResize(trends,Bars);
         
   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
      if (trends[Bars-limit-1][0] == -1) CleanPoint(limit,hmada,hmadb);
      if (trends[Bars-limit-1][1] == -1) CleanPoint(limit,hmbda,hmbdb);
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         double hma1   = iHma(iMA(NULL,0,1,0,MODE_SMA,FastHullPrice,i),FastHullLength,i,0);
         double hma2   = iHma(hma1                                    ,FastHullLength,i,1);
                hma[i] = 2.0*hma1-hma2;
                hma1   = iHma(iMA(NULL,0,1,0,MODE_SMA,SlowHullPrice,i),SlowHullLength,i,2);
                hma2   = iHma(hma1                                    ,SlowHullLength,i,3);
                hmb[i] = 2.0*hma1-hma2;

         //
         //
         //
         //
         //
         
         hmada[i] = EMPTY_VALUE;
         hmadb[i] = EMPTY_VALUE;
         hmbda[i] = EMPTY_VALUE;
         hmbdb[i] = EMPTY_VALUE;
         arrUp[i] = EMPTY_VALUE;
         arrDn[i] = EMPTY_VALUE;
         trends[r][0] = trends[r-1][0];
         trends[r][1] = trends[r-1][1];
         trends[r][2] = trends[r-1][2];
            if (hma[i] > hma[i+1]) trends[r][0] =   1;
            if (hma[i] < hma[i+1]) trends[r][0] =  -1;
            if (hmb[i] > hmb[i+1]) trends[r][1] =   1;
            if (hmb[i] < hmb[i+1]) trends[r][1] =  -1;
            if (hma[i] > hmb[i])   trends[r][2] =   1;
            if (hma[i] < hmb[i])   trends[r][2] =  -1;
            if (trends[r][0] == -1) PlotPoint(i,hmada,hmadb,hma);
            if (trends[r][1] == -1) PlotPoint(i,hmbda,hmbdb,hmb);
            if (trends[r][2] != trends[r-1][2])
            {
               if (trends[r][2] ==  1) arrUp[i] = MathMin(hma[i],hmb[i])-iATR(NULL,0,20,i)*0.5;
               if (trends[r][2] == -1) arrDn[i] = MathMax(hma[i],hmb[i])+iATR(NULL,0,20,i)*0.5;
            }               
      }
      manageAlerts();   
      return(0);
   }      

   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (trends[Bars-limit-1][0] == -1) CleanPoint(limit,hmada,hmadb);
   if (trends[Bars-limit-1][1] == -1) CleanPoint(limit,hmbda,hmbdb);
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         hma[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastHullLength,FastHullPrice,SlowHullLength,SlowHullPrice,0,y);
         hmb[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastHullLength,FastHullPrice,SlowHullLength,SlowHullPrice,3,y);
         hmada[i] = EMPTY_VALUE;
         hmadb[i] = EMPTY_VALUE;
         hmbda[i] = EMPTY_VALUE;
         hmbdb[i] = EMPTY_VALUE;
         arrUp[i] = EMPTY_VALUE;
         arrDn[i] = EMPTY_VALUE;
            trends[r][0] = trends[r-1][0];
            trends[r][1] = trends[r-1][1];
            trends[r][2] = trends[r-1][2];
               if (hma[i] > hma[i+1]) trends[r][0] =   1;
               if (hma[i] < hma[i+1]) trends[r][0] =  -1;
               if (hmb[i] > hmb[i+1]) trends[r][1] =   1;
               if (hmb[i] < hmb[i+1]) trends[r][1] =  -1;
               if (hma[i] > hmb[i])   trends[r][2] =   1;
               if (hma[i] < hmb[i])   trends[r][2] =  -1;
               if (trends[r][2] != trends[r-1][2])
               {
                  if (trends[r][2] ==  1) arrUp[i] = MathMin(hma[i],hmb[i])-iATR(NULL,0,20,i)*0.5;
                  if (trends[r][2] == -1) arrDn[i] = MathMax(hma[i],hmb[i])+iATR(NULL,0,20,i)*0.5;
               }               
         
         //
         //
         //
         //
         //
       
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               hma[i+k] = hma[i]+(hma[i+n]-hma[i])*k/n;
               hmb[i+k] = hmb[i]+(hmb[i+n]-hmb[i])*k/n;
            }               
   }
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      if (trends[r][0] == -1) PlotPoint(i,hmada,hmadb,hma);
      if (trends[r][1] == -1) PlotPoint(i,hmbda,hmbdb,hmb);
   }   
   
   //
   //
   //
   //
   //

   manageAlerts();   
   return(0);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trends[Bars-whichBar-1][2] != trends[Bars-whichBar-2][2])
      {
         if (trends[Bars-whichBar-1][2] == 1) doAlert(whichBar,"up");
         if (trends[Bars-whichBar-1][2] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ZL Hull CD trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"ZL Hull CD"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

double wrk[][8];

//
//
//
//
//

double iHma(double price, int period, int i, int s=0)
{
   if (ArrayRange(wrk,0)!=Bars) ArrayResize(wrk,Bars);
   
   //
   //
   //
   //
   //
   
      int HMAPeriod  = MathMax(2,period);
      int HalfPeriod = MathFloor(HMAPeriod/2);
      int HullPeriod = MathFloor(MathSqrt(HMAPeriod));

      //
      //
      //
      //
      //

      s = s*2;         
      int r = Bars-i-1;  
         wrk[r][s  ] = price;
         wrk[r][s+1] = 2.0*iLwma(s,HalfPeriod,r)-iLwma(s,HMAPeriod,r);
      return (iLwma(s+1,HullPeriod,r));
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

double iLwma(int forBuffer, int period, int r)
{
   double weight = 0;
   double sum    = 0;
   int    i,k;
   
   if (r>=period)
   {
      for (i=0, k=period; i<period; i++,k--)
      {
            weight += k; sum += wrk[r-i][forBuffer]*k;
      }
      if (weight !=0)
            return(sum/weight);
      else  return(0.0);
    }
    else return(wrk[r][forBuffer]);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}